counter=200

function mission_start()
    hudmsgbox("Defend your base and survive as long as you can!")
    cc.mg.bullet.move=bulletoverwrite
    cc.baseballbat.attack=replacebat
    cc.shotgun.bullet.move=shotgunreplace
    cc.sniper.bullet.move=sniperreplace
    cc.minig.bullet.move=minigreplace
    cc.missilebat.missile.move=missilereplace
level_start()
end

function mission_update()
         if (getframe()%50)==0 and math.random(1,5)==1 then
                  createobject(loooser.zombie.zombie.id,getnodex("zspawn"),getnodey("zspwan"))
                  createobject(loooser.zombie.zombie.id,getnodex("zspawn2"),getnodey("zspwan2"))
         end
         counter=counter-1
         if counter<0 then
         counter=200
                 createobject(o_supply,getnodex("supplynode"),getnodey("supplynode"))
         end
  level_update()
end


function mission_draw()
         setbgcolor(0,0,0)
  level_draw()
end


function level_start()

end

function level_update()

end


function level_draw()
end

function bulletoverwrite(id)
         rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                -- Cause damage
                                if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
                                        playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                        playerdamage(playercollision(),2)
                                        blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                                elseif objectcollision()>0 then
                                        objectdamage(objectcollision(),15)
                                end
                                -- Effects
                                playsound(sfx_ricochet1)
                                particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                particlefadealpha(0.006)
                                particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                -- Free projectile
                                freeprojectile(id)
                                return 1
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

function replacebat(attack)                                                                                                        -- Attack
        if (weapon_shots<=0) then
                if (attack==1) then
                        -- No more weapon switching!
                        useweapon(0)
                        playsound(cc.baseballbat.sfx_attack)
                        weapon_shots=weapon_shots+1
                        -- Set timer for animation
                        weapon_timer=30
                        -- Collision
                        col=0
                        for dist=5,20,5 do
                                for i=-2,2,1 do
                                        if col==0 then
                                                if collision(col5x5,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)+(i*10)))*dist,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)+(i*10)))*dist,0,0,1)==1 then
                                                        if objectcollision()>0 then
                                                                objectpush(objectcollision(),math.sin(math.rad(getplayerrotation(0)))*13,-math.cos(math.rad(getplayerrotation(0)))*13,1)
                                                                objectdamage(objectcollision(),200)
                                                                playsound(sfx_splatter1)
                                                                particle(p_ring,getobjectx(objectcollision()),getobjecty(objectcollision()))
                                                                particlecolor(255,0,0)
                                                                blood(getobjectx(objectcollision()),getobjecty(objectcollision()))
                                                                col=1
                                                                break
                                                        end
                                                end
                                        end
                                end
                        end
                        -- End Turn
                        endturn()
                end
        end
end

function shotgunreplace(id)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                -- Cause damage
                                if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
                                        playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                        playerdamage(playercollision(),5)
                                        blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                                elseif objectcollision()>0 then
                                        objectdamage(objectcollision(),15)
                                end
                                -- Effects
                                playsound(sfx_ricochet1)
                                particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                particlefadealpha(0.004)
                                particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                -- Free projectile
                                freeprojectile(id)
                                return 1
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

function sniperreplace(id)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                -- Cause damage
                                if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
                                        playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                        playerdamage(playercollision(),50)
                                        blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                                elseif objectcollision()>0 then
                                        objectdamage(objectcollision(),101)
                                end
                                -- Effects
                                playsound(sfx_ricochet1)
                                particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                particlefadealpha(0.006)
                                particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                -- Free projectile
                                freeprojectile(id)
                                return 1
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

function minigreplace(id)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                -- Cause damage
                                if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
                                        playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                        playerdamage(playercollision(),1)
                                        blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                                elseif objectcollision()>0 then
                                        objectdamage(objectcollision(),15)
                                end
                                -- Effects
                                playsound(sfx_ricochet1)
                                particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                particlefadealpha(0.006)
                                particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                                -- Free projectile
                                freeprojectile(id)
                                return 1
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

function missilereplace(id,fx)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Particle Tail
        if (fx==1) then
                particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
                particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
                particlefadealpha(0.01)
                particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
                particlefadealpha(0.04)
        end
        -- Wind + Gravity influence on speed
        projectiles[id].sx=projectiles[id].sx+getwind()*0.5
        projectiles[id].sy=projectiles[id].sy+getgravity()*1.5
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                -- Cause damage
                                arealdamage(projectiles[id].x,projectiles[id].y,70,100)
                                -- Destroy terrain
                                terrainexplosion(projectiles[id].x,projectiles[id].y,20,3)
                                -- Crater
                                grey=math.random(0,40)
                                if math.random(0,1)==1 then
                                        terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                else
                                        terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                end
                                -- Free projectile
                                freeprojectile(id)
                                break
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        playsound(sfx_hitwater1)
                        -- Free projectile
                        freeprojectile(id)
                        break
                end
        end
end